﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Reflection;


namespace GlobalHookDemo
{
    public class KeyboardWriter
    {
        const uint KEYEVENTF_KEYUP = 0x0002;
        const uint KEYEVENTF_EXTENDEDKEY = 0x0001;

        [DllImport("user32.dll")]
        static extern void keybd_event(byte bVk, byte bScan, uint dwFlags,
           int dwExtraInfo);
        [DllImport("user32.dll")]
        static extern uint MapVirtualKey(uint uCode, uint uMapType);
        [DllImport("user32.dll")]
        static extern short VkKeyScan(char ch);


        public static void SendKeys(String text)
        {
            System.Windows.Forms.SendKeys.SendWait(text);
        }

        public static void SendKeys2(String text)
        {
            foreach (char c in text)
            {
                int code = VkKeyScan(c);
                int lower = code >> 8;
                bool shift = (lower & 1) != 0;
                bool alt = (lower & 6) != 0;

                if (shift)
                {
                    keyDown((int)Keys.ShiftKey);
                }
                if (alt)
                {
                    pressWithAlt((byte)code);
                }
                else
                {
                    pressKey((byte)code);
                }
                if (shift)
                {
                    keyUp((int)Keys.ShiftKey);
                }
            }
        }

        private static void keyDown(byte c)
        {
            keybd_event(c,(byte) MapVirtualKey(c,0), KEYEVENTF_EXTENDEDKEY | 0, 0);
        }

        private static void keyUp(byte c)
        {
            keybd_event(c, (byte) MapVirtualKey(c, 0), KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
        }

        private static void pressKey(byte c)
        {
            keyDown(c);
            keyUp(c);
        }

        private static void pressWithAlt(byte c)
        {
            keyDown(165);
            keyDown(c);
            keyUp(c);
            keyUp(165);
        }
    }
}
