﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using System.Windows.Interop;
using GlobalHookDemo.Views;


namespace GlobalHookDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class LoadingWindow : Window
    {
        [DllImport("user32.dll")]
        public static extern IntPtr SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);
        [DllImport("user32.dll")]
        public static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        private const int GWL_EXSTYLE = -20;
        private Button button1;
        private const int WS_EX_NOACTIVATE = 0x08000000;
        private IntPtr Handle;

        public LoadingWindow()
        {
            InitializeComponent();
            Handle = new WindowInteropHelper(this).Handle;
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
        }

        protected override void OnActivated(EventArgs e)
        {
            base.OnActivated(e);
            WindowInteropHelper helper = new WindowInteropHelper(this);
            SetWindowLong(helper.Handle, GWL_EXSTYLE, GetWindowLong(helper.Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
        }

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);

            this.Dispatcher.BeginInvoke((Action)(() =>
            {
                AsyncCallback callback = new AsyncCallback(LoadDataBase);
                callback.BeginInvoke(null, new AsyncCallback(LoadingCompleted), null);
            }));
        }

        protected void LoadDataBase(IAsyncResult result)
        {
            DictionaryApi.Instance.readDictionary(System.IO.File.ReadAllText("slownik.txt"));
        }

        protected void LoadingCompleted(IAsyncResult result)
        {
            this.Dispatcher.BeginInvoke((Action)(() =>
            {
                MainWindow mw = new MainWindow();
                mw.Show();
                this.Close();
            }));
        }
    }
}
