﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using System.Windows.Interop;
using GlobalHookDemo.Views;

namespace GlobalHookDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        [DllImport("user32.dll")]
        public static extern IntPtr SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);
        [DllImport("user32.dll")]
        public static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        private const int GWL_EXSTYLE = -20;
        private Button Ustawienia;
        private const int WS_EX_NOACTIVATE = 0x08000000;
        private IntPtr Handle;


        public MainWindow()
        {
            InitializeComponent();
            Handle = new WindowInteropHelper(this).Handle;
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
            Closed += new EventHandler(MainWindow_Closed);
            //this.MinimizeBox = false;
            //this.MaximizeBox = false;
        }

        void MainWindow_Closed(object sender, EventArgs e)
        {
            DictionaryApi.Instance.SaveDictionary();
        }

        protected override void OnActivated(EventArgs e)
        {
            base.OnActivated(e);
            WindowInteropHelper helper = new WindowInteropHelper(this);
            SetWindowLong(helper.Handle, GWL_EXSTYLE, GetWindowLong(helper.Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
        }

        protected void OnGotFocus(object sender, RoutedEventArgs e)
        {
            base.OnActivated(e);
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);

        }

        // THIS METHOD IS MAINTAINED BY THE FORM DESIGNER
        // DO NOT EDIT IT MANUALLY! YOUR CHANGES ARE LIKELY TO BE LOST
        //void InitializeComponent()
        //{
        //    this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
        //    this.ClientSize = new System.Drawing.Size(306, 169);
        //    this.Controls.Add(this.dictionaryControl);
        //    this.Controls.Add(this.Ustawienia);
        //    this.Name = "MainForm";
        //    this.Text = "Dictionary";
        //    this.ResumeLayout(false);

        //}

        private void Ustawienia_Click_1(object sender, EventArgs e)
        {
            var control = (MainFrame.Content as DictionaryControl);

            control.IsHooksEnabled = false;

            FontChooser fontChooser = new FontChooser();
            fontChooser.Owner = this;

            fontChooser.SetPropertiesFromObject(control.textBox1);
            fontChooser.SetPropertiesFromObject(control.listBox1);
            if (fontChooser.ShowDialog().Value)
            {
                fontChooser.ApplyPropertiesToObject(control.textBox1);
                fontChooser.ApplyPropertiesToObject(control.listBox1);
            }

            Properties.Settings.Default.FontSize = fontChooser.SelectedFontSize;
            Properties.Settings.Default.FontFamily = fontChooser.SelectedFontFamily;
            Properties.Settings.Default.FontStretch = fontChooser.SelectedFontStretch;
            Properties.Settings.Default.FontStyle = fontChooser.SelectedFontStyle;
            Properties.Settings.Default.FontWeight = fontChooser.SelectedFontWeight;
            Properties.Settings.Default.Save();
            control.update();
            control.IsHooksEnabled = true;
            
        }

        private void exitButtonClick(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void AboutButton_Click(object sender, RoutedEventArgs e)
        {
            AboutControl about = new AboutControl();
            about.Owner = this;
            about.Show();
        }
    }
}
