﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Forms;
using System.Drawing;
using System.Timers;
using System.ComponentModel;



namespace GlobalHookDemo.Views
{
    /// <summary>
    /// Interaction logic for DictionaryControl.xaml
    /// </summary>
    /// 


    public partial class DictionaryControl : System.Windows.Controls.UserControl
    {

        private string currentString = "";
        private string lastWord = "";
        private int currentPosition = 0;
        System.Timers.Timer aTimer = new System.Timers.Timer();
        System.Timers.Timer DeadTimer = new System.Timers.Timer();
        public string Interval;
        public string deadInterval;
        bool AbleToChooseNextWord = true;
        bool WordSelected = false;
        public int ChosenWordInList = -1;
        public int numberOfSpace = 0;
        public bool IsHooksEnabled { get; set; }
        public double indexY;
        public double indexX;

        public void update()
        {
            var words = DictionaryApi.Instance.findWordsStartWith(currentString);
            listBox1.ItemsSource = words.ToArray();
        }

        public DictionaryControl()
        {
            IsHooksEnabled = true;
            InitializeComponent();
            KeyboardHook.getInstance().Entered += new KeyboardHook.KeyEntered(DictionaryControl_Entered);
            listBox1.SelectionChanged += new SelectionChangedEventHandler(listBox1_SelectedIndexChanged);
            textBox1.TextChanged += new TextChangedEventHandler(textBox1_TextChanged);
            textBox1.TextInput += new System.Windows.Input.TextCompositionEventHandler(textBox1_TextInput);
            listBox1.FontSize = textBox1.FontSize = Properties.Settings.Default.FontSize;
            listBox1.FontFamily = textBox1.FontFamily = Properties.Settings.Default.FontFamily;
            listBox1.FontStretch = textBox1.FontStretch = Properties.Settings.Default.FontStretch;
            listBox1.FontStyle = textBox1.FontStyle = Properties.Settings.Default.FontStyle;
            listBox1.FontWeight = textBox1.FontWeight = Properties.Settings.Default.FontWeight;
            listBox1.ItemsSource = DictionaryApi.Instance.findWordsStartWith("");
            listBox1.MouseMove += new System.Windows.Input.MouseEventHandler(listBox1_MouseMove);


            
        }

        void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (!IsHooksEnabled)
                return;
            aTimer.Enabled = false;
            aTimer.Stop();
            aTimer.Close();
            aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);


            if (currentString.Contains(' ') && currentString[0] != (' '))
            {
                var zlepki = DictionaryApi.Instance.findWordsStartWith(currentString);
                listBox1.ItemsSource = zlepki.ToArray();
            }
            else if (currentString.Equals(""))
            {
                var words = DictionaryApi.Instance.findWordsStartWith(currentString);
                if (words.Count() == 0)
                    words = DictionaryApi.Instance.findMostPopular();
                listBox1.ItemsSource = words.ToArray();
            }
            else if (currentString[0] == ' ')
            {
                var words = DictionaryApi.Instance.findWordsStartWith(currentString);
                if (words.Count() == 0)
                    words = DictionaryApi.Instance.findMostPopular();
                listBox1.ItemsSource = words.ToArray();
            }
            else if (currentString.Equals("\n"))
            {
                var words = DictionaryApi.Instance.findWordsStartWith(currentString);
                if (words.Count() == 0)
                    words = DictionaryApi.Instance.findMostPopular();
                listBox1.ItemsSource = words.ToArray();

            }

            else
            {
                var words = DictionaryApi.Instance.findWordsStartWith(currentString);
                listBox1.ItemsSource = words.ToArray();
            }
        }

        private delegate void updateDelegate(string text);

        private void updateTextBox(string text)
        {
            if (!IsHooksEnabled)
               return;
            if (!WordSelected)
            {
                string selectedText = listBox1.Items.GetItemAt(ChosenWordInList).ToString();
                if (currentString == "")
                {
                    string ToAdd1 = currentString.Equals("") ? selectedText: selectedText.ToLower().Remove(0, currentString.ToLower().Length);// +" ";
                    //DictionaryApi.Instance.updateUsage(selectedText, null);
                    KeyboardWriter.SendKeys2(ToAdd1);
                    numberOfSpace = 0;
                    listBox1.SelectedIndex = -1;
                    currentString = selectedText;
                    textBox1.Text = currentString;
                    currentPosition = textBox1.Text.Length;
                    textBox1.Focus();
                }
                else if (currentString != "" && currentString[0] == ' ')
                {
                    string ToAdd1 = currentString.Equals("") ? selectedText: selectedText.ToLower().Remove(0, currentString.ToLower().Length - 1);// +" ";
                    //DictionaryApi.Instance.updateUsage(selectedText, null);
                    KeyboardWriter.SendKeys2(ToAdd1);
                    numberOfSpace = 0;
                    listBox1.SelectedIndex = -1;
                    currentString = selectedText;
                    textBox1.Text = currentString;
                    currentPosition = textBox1.Text.Length;
                    textBox1.Focus();
                }
                else if (currentString != "" && currentString[0] != ' ' && numberOfSpace == 0)
                {
                    string ToAdd1 = currentString.Equals("") ? selectedText: selectedText.ToLower().Remove(0, currentString.ToLower().Length);// +" ";
                    //DictionaryApi.Instance.updateUsage(selectedText, null);
                    KeyboardWriter.SendKeys2(ToAdd1);
                    numberOfSpace = 0;
                    listBox1.SelectedIndex = -1;
                    currentString = selectedText;
                    textBox1.Text = currentString;
                    currentPosition = textBox1.Text.Length;
                    textBox1.Focus();
                }

                else if (numberOfSpace == 1 && currentString[0] != ' ')
                {
                    string[] arrayOfTextBox = currentString.Split(' ');
                    string ToAdd1 = arrayOfTextBox[1].Equals("") ? selectedText : selectedText.ToLower().Remove(0, arrayOfTextBox[1].ToLower().Length); ;
                    //DictionaryApi.Instance.updateUsage(arrayOfTextBox[0], selectedText);
                    KeyboardWriter.SendKeys2(ToAdd1);
                    //numberOfSpace = 1;
                    listBox1.SelectedIndex = -1;
                    //currentString = currentString;
                    textBox1.Text = currentString;
                    currentPosition = textBox1.Text.Length;
                    textBox1.Focus();
                }
                else
                {
                    ; ;
                }
            }
            WordSelected = true;


            string[] array;
            System.IO.StreamReader file = new System.IO.StreamReader(System.IO.Directory.GetCurrentDirectory() + "\\config.txt");
            array = file.ReadLine().Split(',');
            deadInterval = array[1];
            file.Close();

            char liczba;
            liczba = deadInterval[0];
            double DeadNumerical;
            DeadNumerical = (liczba - '0') * 1000;

            AbleToChooseNextWord = false;

            DeadTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
            DeadTimer.Interval = DeadNumerical;
            DeadTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
            DeadTimer.AutoReset = false;
            DeadTimer.Enabled = true;


        }


        public void listBox1_MouseMove(object sender, System.Windows.Input.MouseEventArgs e)
        {
                System.Windows.Point ptCursor = e.GetPosition(listBox1);
                System.Windows.Controls.ListBox lb = new System.Windows.Controls.ListBox();
                indexX = ptCursor.X;
                indexY = ptCursor.Y;

                string[] array;
                System.IO.StreamReader file = new System.IO.StreamReader(System.IO.Directory.GetCurrentDirectory() + "\\config.txt");
                array = file.ReadLine().Split(',');
                Interval = array[0];
                file.Close();

                char liczba;
                liczba = Interval[0];
                double intervalNumerical;
                intervalNumerical=(liczba - '0')*1000;
               

                double BondsOfItems = listBox1.Height/3;
                double HorizontalBonds = 280;

                if (AbleToChooseNextWord)
                {
                    WordSelected = false;
                    if (indexY > 10 && indexY <= (BondsOfItems - 4) && indexX > 1 && indexX < HorizontalBonds)
                    {
                        ChosenWordInList = 0;
                        aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        aTimer.Interval = intervalNumerical;
                        aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                        aTimer.AutoReset = false;
                        aTimer.Enabled = true;
                    }
                    else if (indexY > (BondsOfItems-4) && indexY <= ((BondsOfItems * 2) - 8) && indexX > 1 && indexX < HorizontalBonds)
                    {
                        ChosenWordInList = 1;
                        aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        aTimer.Interval = intervalNumerical;
                        aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                        aTimer.AutoReset = true;
                        aTimer.Enabled = true;
                    }
                    else if (indexY > ((BondsOfItems * 2) - 8) && indexY < ((BondsOfItems * 3) - 12) && indexX > 1 && indexX < HorizontalBonds)
                    {
                        ChosenWordInList = 2;
                        aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        aTimer.Interval = intervalNumerical;
                        aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                        aTimer.AutoReset = true;
                        aTimer.Enabled = true;
                    }
                   /* else if (indexY > BondsOfItems * 3 && indexY < ((BondsOfItems * 3) - 16) && indexX > 1 && indexX < HorizontalBonds)
                    {
                        ChosenWordInList = 3;
                        aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        aTimer.Interval = intervalNumerical;
                        aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                        aTimer.AutoReset = false;
                        aTimer.Enabled = true;
                    }*/
                    else
                    {
                        //aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        aTimer.Stop();
                        aTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
                        
                    }
                }
        }
        void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (!IsHooksEnabled)
                return;

            if (listBox1.SelectedItem == null)
                return;

            string selectedText = listBox1.SelectedItem.ToString();
            WordSelected = false;
            if (currentString == "")
            {
                
                string ToAdd1 = currentString.Equals("") ? selectedText: selectedText.ToLower().Remove(0, currentString.ToLower().Length);
                //DictionaryApi.Instance.updateUsage(selectedText, null);
                KeyboardWriter.SendKeys2(ToAdd1);
                numberOfSpace = 0;
                listBox1.SelectedIndex = -1;
                currentString = selectedText;
                textBox1.Text = currentString;
                currentPosition = textBox1.Text.Length;
                textBox1.Focus();
            }
            else if (currentString != "" && currentString[0] == ' ')
            {
                string ToAdd1 = currentString.Equals("") ? selectedText : selectedText.ToLower().Remove(0, currentString.ToLower().Length - 1);
                //DictionaryApi.Instance.updateUsage(selectedText, null);
                KeyboardWriter.SendKeys2(ToAdd1);
                numberOfSpace = 0;
                listBox1.SelectedIndex = -1;
                currentString = selectedText;
                textBox1.Text = currentString;
                currentPosition = textBox1.Text.Length;
                textBox1.Focus();
            }
            else if (currentString != "" && currentString[0] != ' ' && numberOfSpace == 0)
            {
                string ToAdd1 = currentString.Equals("") ? selectedText : selectedText.ToLower().Remove(0, currentString.ToLower().Length);
                //DictionaryApi.Instance.updateUsage(selectedText, null);
                KeyboardWriter.SendKeys2(ToAdd1);
                numberOfSpace = 0;
                listBox1.SelectedIndex = -1;
                currentString = selectedText;
                textBox1.Text = currentString;
                currentPosition = textBox1.Text.Length;
                textBox1.Focus();
            }

            else if (numberOfSpace == 1 && currentString[0] != ' ')
            {
            
                string[] arrayOfTextBox = currentString.Split(' ');
                string ToAdd1 = arrayOfTextBox[1].Equals("") ? selectedText : selectedText.ToLower().Remove(0, arrayOfTextBox[1].ToLower().Length);
                //DictionaryApi.Instance.updateUsage(arrayOfTextBox[0], selectedText);
                KeyboardWriter.SendKeys2(ToAdd1);
                listBox1.SelectedIndex = -1;
                //currentString = selectedText;
                textBox1.Text = currentString;
                currentPosition = textBox1.Text.Length;
                textBox1.Focus();
            }
            else ; ;
            WordSelected = false;

        }
        
        public void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            if (AbleToChooseNextWord)    
                textBox1.Dispatcher.BeginInvoke(new updateDelegate(updateTextBox), this.listBox1.Items.GetItemAt(ChosenWordInList).ToString());
            if (!AbleToChooseNextWord) 
                AbleToChooseNextWord = true;
        }


        public void textBox1_TextInput(object sender, EventArgs e )
        {
            this.textBox1.Text = this.listBox1.Items.GetItemAt(ChosenWordInList).ToString();
        }


        void DictionaryControl_Entered(object sender, KeyboardEventArgs e)
        {
            
            if (!IsHooksEnabled)
                return;

            try
            {
                if (e.key != null)
                {
                    string txt = e.key;
                    if (String.Compare(txt, "selected") == 0)
                    {

                        listBox1.SelectedIndex = 0;
                        return;
                    }
                    currentString = currentString.Insert(currentPosition, txt);
                    currentPosition += txt.Length;

                    

                    if (txt[0] == ' ')
                    {
                        numberOfSpace++;
                        if (numberOfSpace == 2 && !currentString.StartsWith(" "))
                        {
                            if (currentString[currentPosition - 2] == ' ')
                            {
                                currentString = currentString.TrimEnd();
                                DictionaryApi.Instance.addWord(currentString, null);
                            }
                            else
                            {
                                currentString = currentString.TrimEnd();
                                string[] wordsArray = currentString.Split(' ');
                                DictionaryApi.Instance.addWord(wordsArray[0], wordsArray[1]);
                                lastWord = wordsArray[1];
                            }
                            numberOfSpace = 1;
                            currentString = lastWord+" ";
                            currentPosition = currentString.Length;
                        }
                        else if (numberOfSpace == 2 && currentString.StartsWith(" "))
                        {
                            if (currentString[1] == ' ')
                            {
                                numberOfSpace = 0;
                                currentString = "";
                                currentPosition = currentString.Length;
                            }
                            if (currentString[1] != ' ')
                            {
                                currentString = currentString.Trim();
                                DictionaryApi.Instance.addWord(currentString, null);
                                numberOfSpace = 0;
                                currentString = "";
                                currentPosition = currentString.Length;
                            }
                        }
                        else
                        {
                            ; ;
                        }
                    }
                    else if (txt[0] == '\n')
                    {
                        if (numberOfSpace == 1 && currentString.StartsWith(" "))
                        {
                            currentString = currentString.TrimStart();
                            DictionaryApi.Instance.addWord(currentString, null);
                            numberOfSpace = 0;
                            this.currentString = "";
                            currentPosition = 0;
                            
                        }
                        else if (numberOfSpace == 1 && !currentString.StartsWith(" "))
                        {
                            string[] wordsArray = currentString.Split(' ');
                            DictionaryApi.Instance.addWord(wordsArray[0], wordsArray[1]);
                            numberOfSpace = 0;
                            this.currentString = "";
                            currentPosition = currentString.Length;
                        }
                        else if (numberOfSpace == 1 && currentString.Equals(" "))
                        {
                            numberOfSpace = 0;
                            currentString = "";
                            currentPosition = currentString.Length;
                        }
                        else if (numberOfSpace == 0 && currentString!=(" ")&&currentString!="\n")
                        {
                            DictionaryApi.Instance.addWord(currentString, null);
                            numberOfSpace = 0;
                            lastWord = "";
                            this.currentString = "";
                            currentPosition = 0;

                        }
                        else
                        {
                            numberOfSpace = 0;
                            lastWord = "";
                            this.currentString = "";
                            currentPosition = currentString.Length;
                        }
                    }
                    else
                    {
                        ; ;
                    }
                }
                if (e.specialKey != KeyboardEventArgs.SpecialKey.None)
                {
                    switch (e.specialKey)
                    {
                        case KeyboardEventArgs.SpecialKey.Left:
                            currentPosition = Math.Max(0, currentPosition - 1);
                            break;
                        case KeyboardEventArgs.SpecialKey.Right:
                            currentPosition = Math.Min(currentString.Length, currentPosition + 1);
                            break;
                        case KeyboardEventArgs.SpecialKey.Backspace:
                            if (currentString.Length != 0 && currentPosition != 0)
                            {
                                if (currentString[currentPosition - 1] == ' ')
                                    numberOfSpace--;
                                currentString = currentString.Remove(currentPosition - 1, 1);
                                currentPosition -= 1;
                            }
                            break;
                        case KeyboardEventArgs.SpecialKey.Delete:
                            if (currentString.Length != 0 && currentPosition < currentString.Length)
                            {
                                currentString = currentString.Remove(currentPosition, 1);
                            }
                            break;
                    }
                }
                textBox1.Text = currentString;
            }
            catch
            { }
        }

    }
}
